using System;
using System.Collections.Generic;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml;

//This code is the modified version of the sample code provided in Andrew Connell's book :Professional SharePoint //2007 Web Content Management Development 
//http://www.devhorizon.com/go/112 


namespace WeatherWebPart
{
    public class WeatherWebPart : WebPart
    {
        protected override void CreateChildControls()
        {
            base.CreateChildControls();
            // create async task to go get RSS feed
            WorkerTask task = new WorkerTask();
            PageAsyncTask asyncTask = new PageAsyncTask(task.OnBegin,
                                                        task.OnEnd,
                                                        task.OnTimeout,
                                                        "RssFetcherTask",
                                                        true);
            Page.RegisterAsyncTask(asyncTask);
            Page.ExecuteRegisteredAsyncTasks();

            #region DO UI adjustment (has nothing to do with async stuff
            // loop through posts and display
            int postCounter = 0;
            HyperLink link;
            string displayID = "_WPQID_WeatherDisplay";
            if (task.TaskResults != null && task.TaskResults.Count > 0)
                foreach (XmlNode post in task.TaskResults)
                {
                    postCounter++;

                    // create new link
                    link = new HyperLink();
                    link.NavigateUrl = post.SelectSingleNode("link").InnerText;
                    link.Text = post.SelectSingleNode("title").InnerText;

                    // add rollover effects
                    link.Attributes.Add("onMouseOver", "document.all." + displayID + ".innerHTML='" + post.SelectSingleNode("description").InnerText + "';");
                    link.Attributes.Add("onMouseOut", "document.all." + displayID + ".innerHTML='';");

                    Controls.Add(new LiteralControl("&raquo;&nbsp;"));
                    Controls.Add(link);
                    Controls.Add(new LiteralControl("<br />"));

                    // only show last 5 posts in the feed
                    if (postCounter >= 5) break;
                }

            // weather feed entry contents
            Controls.Add(new LiteralControl("<div id=\"" + displayID + "\"></div>")); 
            #endregion
        }

    }
}
