using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.SharePoint;
using Microsoft.SharePoint.Administration;

namespace BlendedConfigMgmnt
{
    class CRMWsUrl : SPFeatureReceiver
    {
        public const string WebServicesUrlKey = "CRMWsUrl";

        public override void FeatureActivated(SPFeatureReceiverProperties properties)
        {
            SPWebApplication wepApp = properties.Feature.Parent as SPWebApplication;
            if (wepApp != null)
            {
                wepApp.Properties.Add(WebServicesUrlKey, "http://dhdemo/mscrmservices/2007/crmservice.asmx");
                wepApp.Update();
            }

        }

        public override void FeatureDeactivating(SPFeatureReceiverProperties properties)
        {
           
            SPWebApplication wepApp = properties.Feature.Parent as SPWebApplication;
            if (wepApp != null)
            {
                if (wepApp.Properties.ContainsKey(WebServicesUrlKey))
                {
                    wepApp.Properties.Remove(WebServicesUrlKey);
                    wepApp.Update();
                }
            }

        }

        public override void FeatureInstalled(SPFeatureReceiverProperties properties)
        {
            throw new Exception("The method or operation is not implemented.");
        }

        public override void FeatureUninstalling(SPFeatureReceiverProperties properties)
        {
            throw new Exception("The method or operation is not implemented.");
        }
    }
}
