/**
* This code is provided "AS IS", without warranty of any kind.
* This is a sample code, might be not completely error free.
* DevHorizon or author of this code doesn't take any responsibility
* what so ever resulting out of usage of this code.
*/

using System;
using System.Text;
using System.Globalization;
using System.Collections.Generic;
using Microsoft.SharePoint;
using Microsoft.SharePoint.Administration;
using System.IO;
using System.Configuration;
using Microsoft.SharePoint.Utilities;
using System.Web.Configuration;

namespace GAEGlobalASAX
{
    /// <summary>
    /// A Feature Reciever for GAEGlobalASAX
    /// </summary>
    public class GAEFeatureReceiver : SPFeatureReceiver
    {
        public override void FeatureInstalled(SPFeatureReceiverProperties properties) { }
        public override void FeatureUninstalling(SPFeatureReceiverProperties properties) { }
        public override void FeatureActivated(SPFeatureReceiverProperties properties)
        {

            SPSite site = properties.Feature.Parent as SPSite;    // get site reference
            SPWebApplication webApp = site.WebApplication as SPWebApplication;
           
            foreach (SPUrlZone zone in webApp.IisSettings.Keys)
            {
                // The settings of the IIS application to update  
                SPIisSettings oSettings = webApp.IisSettings[zone];
                if (oSettings.AuthenticationMode == AuthenticationMode.Forms)
                {
                    if (oSettings.MembershipProvider == "MinimalMembershipProvider")
                    {
                        // Determine the source and destination path     
                        string sourcePath = string.Format(@"{0}\FEATURES\{1}\", SPUtility.GetGenericSetupPath("Template"), @"\GAEGlobalASAX");
                        string destPath = oSettings.Path.ToString();
                        
                        //*******WHAT'S WRONG WITH THIS CODE?************
                        File.Move(Path.Combine(destPath, "global.asax"), Path.Combine(destPath, "global_backup.asax"));                        
                        File.Copy(Path.Combine(sourcePath, "global.asax"), Path.Combine(destPath, "global.asax"), true);
                    }
                }
            }
        }

       
        public override void FeatureDeactivating(SPFeatureReceiverProperties properties)
        {
            SPSite site = properties.Feature.Parent as SPSite;    // get site reference
            SPWebApplication webApp = site.WebApplication as SPWebApplication;


            //Important: 
            //1)The following code must be executed in the context of a user who has appropriate permissions to access 
            //the file system and perform Move and Copy operations (Site collection admin may not have that level of access). 
            //Use SPSecurity.RunWithElevatedPriveleges if required or Change the scope of the feature to be at Farm or
            //Web Application level to make sure that Feature Deactivating doesn't fail due to the lack of permission.

            //2)In a farm installation where there are multiple WFEs , the following Move and Copy operations only happen on 
            //the WFE you end up being by the load balancer. You need to manaully update other WFEs or 
            //take a look at GAEHttpHandler example for a more Farm-scoped solution (http://blogs.devhorizon.com/reza/?p=551).

            //3)Add your error handler code

            foreach (SPUrlZone zone in webApp.IisSettings.Keys)
            {
                // The settings of the IIS application to update  
                SPIisSettings oSettings = webApp.IisSettings[zone];
                if (oSettings.AuthenticationMode == AuthenticationMode.Forms)
                {
                    if (oSettings.MembershipProvider == "MinimalMembershipProvider")
                    {
                        // Determine the source and destination path     
                        string sourcePath = string.Format(@"{0}\FEATURES\{1}\", SPUtility.GetGenericSetupPath("Template"), @"\GAEGlobalASAX");
                        string destPath = oSettings.Path.ToString();
                        File.Delete(Path.Combine(destPath, "global.asax"));
                        File.Move(Path.Combine(destPath, "global_backup.asax"), Path.Combine(destPath, "global.asax"));
                    }
                }
            }
        }

    }
}
